Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshSaver.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshSaver.cpp	(revision 1526)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshSaver.cpp	(revision 2127)
@@ -1,12 +1,12 @@
-/*==========================================================================
+/*========================================================================
  *	(C) 2005 Universitat Jaume I
- *==========================================================================
+ *========================================================================
  *	PROYECT:	GAME TOOLS
- *==========================================================================*/
+ *=======================================================================*/
 /*	CONTENT:	
  *
  *
  *	@file	GeoMeshSaver.cpp
- *==========================================================================*/
+ *=======================================================================*/
 #include	<GeoMeshSaver.h>
 
@@ -14,11 +14,11 @@
 using	namespace	std;
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //		Public:
-//---------------------------------------------------------------------------
-
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
+
+//-------------------------------------------------------------------------
 //	Constructors.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 GeoMeshSaver::GeoMeshSaver()
 {
@@ -29,7 +29,7 @@
 }
 
-//---------------------------------------------------------------------------
-//	Destroyer.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
+//	Destructor.
+//-------------------------------------------------------------------------
 GeoMeshSaver::~GeoMeshSaver()
 {
@@ -37,7 +37,7 @@
 }
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Saves a Mesh into a file.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 size_t	GeoMeshSaver::save(Mesh	*geoMesh,	const	char	*fileNameMesh)
 {
@@ -147,9 +147,11 @@
 }
 
-//------------------------------------------
+//-------------------------------------------------------------------------
 //		Private:
-//------------------------------------------
-
+//-------------------------------------------------------------------------
+
+//-------------------------------------------------------------------------
 //	Write the main mesh.
+//-------------------------------------------------------------------------
 void	GeoMeshSaver::writeMesh(Mesh	*geoMesh)
 {
@@ -226,5 +228,7 @@
 }//	End write mesh.
 
+//-------------------------------------------------------------------------
 //	Write a submesh.
+//-------------------------------------------------------------------------
 void	GeoMeshSaver::writeSubMesh(SubMesh	*geoSubMesh)
 {
@@ -345,5 +349,7 @@
 }
 
+//-------------------------------------------------------------------------
 //	Write the submesh operation chunk and data.
+//-------------------------------------------------------------------------
 void GeoMeshSaver::writeSubMeshOperation(const	SubMesh	*geoSubMesh)
 {
@@ -374,5 +380,7 @@
 }
 
+//-------------------------------------------------------------------------
 //	Write geometry.
+//-------------------------------------------------------------------------
 void	GeoMeshSaver::writeGeometry(VertexBuffer	*vertexBuffer)
 {
@@ -581,5 +589,7 @@
 }
 
+//-------------------------------------------------------------------------
 //	Write Mesh Bounds.
+//-------------------------------------------------------------------------
 void	GeoMeshSaver::writeMeshBounds(Mesh	*geoMesh)
 {
@@ -605,5 +615,7 @@
 }
 
+//-------------------------------------------------------------------------
 //	Calculate the mesh size in bytes.
+//-------------------------------------------------------------------------
 size_t GeoMeshSaver::calcMeshSize(const Mesh	*geoMesh)
 {
@@ -650,5 +662,7 @@
 }
 
+//-------------------------------------------------------------------------
 //	Calc the size in bytes for the submesh.
+//-------------------------------------------------------------------------
 size_t GeoMeshSaver::calcSubMeshSize(const SubMesh	*geoSubMesh)
 {
@@ -677,5 +691,7 @@
 }
 
+//-------------------------------------------------------------------------
 //	Calculate the geometry size in bytes.
+//-------------------------------------------------------------------------
 size_t GeoMeshSaver::calcGeometrySize(const VertexBuffer* vertexBuffer)
 {
@@ -709,5 +725,7 @@
 }
 
+//-------------------------------------------------------------------------
 //	Calculate the skeleton link size in bytes.
+//-------------------------------------------------------------------------
 size_t	GeoMeshSaver::calcSkeletonLinkSize(const Mesh	*geoMesh)
 {
@@ -723,5 +741,7 @@
 }
 
+//-------------------------------------------------------------------------
 //	Write the file header.
+//-------------------------------------------------------------------------
 void GeoMeshSaver::writeFileHeader(void)
 {
@@ -734,5 +754,7 @@
 }
 
+//-------------------------------------------------------------------------
 //	Write a header chunk given.
+//-------------------------------------------------------------------------
 void GeoMeshSaver::writeChunkHeader(unsigned short	id,
 																		unsigned long		size)
@@ -742,5 +764,7 @@
 }
 
+//-------------------------------------------------------------------------
 //	Write integers into the file.
+//-------------------------------------------------------------------------
 void	GeoMeshSaver::writeInts(unsigned long	id,
 															unsigned long	count)
@@ -749,5 +773,7 @@
 }
 
+//-------------------------------------------------------------------------
 //	Write shorts into the file
+//-------------------------------------------------------------------------
 void	GeoMeshSaver::writeShorts(unsigned short	id,
 																unsigned long		count)
@@ -756,5 +782,7 @@
 }
 
+//-------------------------------------------------------------------------
 //	Write float into the file.
+//-------------------------------------------------------------------------
 void	GeoMeshSaver::writeFloats(float						id,
 																unsigned long		count)
@@ -763,5 +791,7 @@
 }
 
+//-------------------------------------------------------------------------
 //	Write a string into the file.
+//-------------------------------------------------------------------------
 void GeoMeshSaver::writeString(const	String	&string)
 {
@@ -769,5 +799,7 @@
 }
 
+//-------------------------------------------------------------------------
 //	Write booleans into the file.
+//-------------------------------------------------------------------------
 void	GeoMeshSaver::writeBools(	const bool id,
 																unsigned	long		count)
@@ -776,4 +808,7 @@
 }
 
+//-------------------------------------------------------------------------
+//	Write skeleton filename.
+//-------------------------------------------------------------------------
 void GeoMeshSaver::writeSkeletonLink(const String& skelName)
 {	
@@ -788,4 +823,7 @@
 }
 
+//-------------------------------------------------------------------------
+//	Write bones assignmets.
+//-------------------------------------------------------------------------
 void GeoMeshSaver::writeMeshBoneAssignment(const VertexBoneAssignment& assign)
 {
@@ -802,4 +840,7 @@
 }
 
+//-------------------------------------------------------------------------
+//	Write bones assignmets.
+//-------------------------------------------------------------------------
 void GeoMeshSaver::writeSubMeshBoneAssignment(const VertexBoneAssignment& assign)
 {
@@ -816,5 +857,7 @@
 }
 
+//-------------------------------------------------------------------------
 //	unnormalize geometry model.
+//-------------------------------------------------------------------------
 void	GeoMeshSaver::unnormalizeModel(Mesh	*geoMesh)
 {
@@ -859,5 +902,5 @@
 			continue;
 		}
-			
+
 		//	For each index of the strip.
 		for (size_t i = 0; i < vertex_buffer->mVertexCount; i++)
Index: GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshViewUI.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshViewUI.h	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshViewUI.h	(revision 2127)
@@ -215,4 +215,8 @@
 	inline void cb_menuRenderTextures_i(fltk::Item*, void*);
 	static void cb_menuRenderTextures(fltk::Item*, void*);
+	inline void cb_menuRenderBoundingBox_i(fltk::Item*, void*);
+	static void cb_menuRenderBoundingBox(fltk::Item*, void*);
+	inline void cb_menuRenderAxes_i(fltk::Item*, void*);
+	static void cb_menuRenderAxes(fltk::Item*, void*);
 	inline void cb_menuStripify_i(fltk::Item*, void*);
 	static void cb_menuStripify(fltk::Item*, void*);
Index: GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshView.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshView.h	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshView.h	(revision 2127)
@@ -37,4 +37,6 @@
 	bool		mCW;
 	bool		mCCW;
+	bool		mBBox;
+	bool		mAxes;
 	bool		mPan;
 	bool		mRotate;
@@ -116,4 +118,12 @@
 	void	activeRotate(){mRotate	=	true;}
 	void	deactiveRotate(){mRotate	=	false;}
+
+	//	Counter Clockwise mode.
+	void	activeAxes(){mAxes	=	true;}
+	void	deactiveAxes(){mAxes	=	false;}
+
+	//	Counter Clockwise mode.
+	void	activeBoundingBox(){mBBox	=	true;}
+	void	deactiveBoundingBox(){mBBox	=	false;}
 
 	//	LodStrip mode.
@@ -170,7 +180,4 @@
 	void draw();
 
-	//	Gets the bounding box.
-	//Geometry::GeometryBounds	getBoundingBox();
-
 	//	Store one random color to each strip.
 	void	setStripColors();
@@ -211,4 +218,10 @@
 	int findLeavesSubMesh(void);
 
+	//	Draw coordinates axes.
+	void	drawAxes();
+
+	//	Draw bounding box.
+	void	drawBoundingBox();
+
 	private:
 	/* Draw the cube boundaries
@@ -242,4 +255,11 @@
 	float		zMed;
 
+	float		xMax;
+	float		yMax;
+	float		zMax;
+	float		xMin;
+	float		yMin;
+	float		zMin;
+
 	int			leavesSubMesh;
 	
@@ -257,4 +277,7 @@
 
 	virtual	int	handle(int event);
+
+	//	Gets the bounding box.
+	void	getBoundingBox();
 
 	//	Paint the mesh object.
Index: GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoMeshViewUI.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoMeshViewUI.cpp	(revision 2103)
+++ GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoMeshViewUI.cpp	(revision 2127)
@@ -653,4 +653,58 @@
 										->
 										cb_menuRenderTextures_i(o,v);
+}
+
+//-------------------------------------------------------------------------
+//	Bounding Box callback
+//-------------------------------------------------------------------------
+inline void GeoMeshViewUI::cb_menuRenderBoundingBox_i(fltk::Item	*item,
+																											void	*v)
+{
+	//	If the item is activated.
+	if (item->value())
+	{
+		geoMeshView->activeBoundingBox();
+	}
+	else
+	{
+		geoMeshView->deactiveBoundingBox();
+	}
+
+	//	Repaint the main window.
+	mMainWindow->redraw();
+}
+
+void GeoMeshViewUI::cb_menuRenderBoundingBox(fltk::Item* o, void* v)
+{
+  ((GeoMeshViewUI*)	(o->parent()->parent()->parent()->user_data()))
+										->
+										cb_menuRenderBoundingBox_i(o,v);
+}
+
+//-------------------------------------------------------------------------
+//	Axes callback
+//-------------------------------------------------------------------------
+inline void GeoMeshViewUI::cb_menuRenderAxes_i(fltk::Item	*item,
+																											void	*v)
+{
+	//	If the item is activated.
+	if (item->value())
+	{
+		geoMeshView->activeAxes();
+	}
+	else
+	{
+		geoMeshView->deactiveAxes();
+	}
+
+	//	Repaint the main window.
+	mMainWindow->redraw();
+}
+
+void GeoMeshViewUI::cb_menuRenderAxes(fltk::Item* o, void* v)
+{
+  ((GeoMeshViewUI*)	(o->parent()->parent()->parent()->user_data()))
+										->
+										cb_menuRenderAxes_i(o,v);
 }
 
@@ -2468,5 +2522,8 @@
 	static	char			title[256];
 	
-	fcho	=	new fltk::FileChooser("", "*.{mesh,obj}", fltk::FileChooser::CREATE, "Open a mesh");
+	fcho	=	new fltk::FileChooser("",
+																"*.{mesh,obj}",
+																fltk::FileChooser::CREATE,
+																"Open a mesh");
 
 	fcho->exec();
@@ -2560,4 +2617,5 @@
 		}
 	}
+
 	//	Free memory.
 	delete	fcho;
@@ -2993,8 +3051,24 @@
 
 				{
-					fltk::Item* o = menuRenderTextures = new fltk::Item("Texture mapping");
+					fltk::Item* o = new fltk::Item("Texture mapping");
 					o->type(fltk::Item::RADIO);
 					o->set_value();
 					o->callback((fltk::Callback*)cb_menuRenderTextures);
+				}
+
+				new fltk::Divider();
+
+				{
+					fltk::Item* o =	new fltk::Item("Axis");
+					o->type(fltk::Item::RADIO);
+					o->set_value();
+					o->callback((fltk::Callback*)cb_menuRenderAxes);
+				}
+
+				{
+					fltk::Item* o =	new fltk::Item("Bounding Box");
+					o->type(fltk::Item::RADIO);
+					o->set_value();
+					o->callback((fltk::Callback*)cb_menuRenderBoundingBox);
 				}
 
@@ -3141,5 +3215,5 @@
 GeoMeshViewUI::~GeoMeshViewUI()
 {
-	delete	geoMeshLoader;
+	//delete	geoMeshLoader;
 	mMainWindow->destroy();
 }
Index: GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoMeshView.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoMeshView.cpp	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoMeshView.cpp	(revision 2127)
@@ -5,7 +5,7 @@
 using	namespace	std;
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Handle events.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 int	GeoMeshView::handle(int event)
 {
@@ -33,12 +33,13 @@
 		case	fltk::DRAG:
 			
-			button	=	fltk::event_state();
+			button	=	fltk::event_key();
 			x				=	fltk::event_x();
 			y				=	fltk::event_y();
 			
+
 			switch (button)
 			{
 				//	Button 1 Pushed.
-				case	0x01100000:
+				case	1:
 			
 					if (x > mMouseX)
@@ -104,5 +105,7 @@
 					return	1;
 				
-				case	0x04100000:
+				//	Button 3 pushed.
+				case	2:
+				case	3:
 
 					if (y	> mSizeY)
@@ -124,5 +127,5 @@
 					return 1;
 
-			}			
+			}
 			
 		case	fltk::MOUSEWHEEL:
@@ -172,7 +175,7 @@
 }
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Enable color strips.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 void	GeoMeshView::enableColorStrips()
 {
@@ -180,7 +183,7 @@
 }
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Disable color strips.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 void	GeoMeshView::disableColorStrips()
 {
@@ -188,7 +191,7 @@
 }
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Gets the color strips state.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 bool	GeoMeshView::getColorStrips()
 {
@@ -196,7 +199,7 @@
 }
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Set the color to the submesh sumbmeshIndex
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 void	GeoMeshView::setSubMeshSelected(int submeshIndex)
 {
@@ -204,7 +207,7 @@
 }
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Sets the leaves submesh index.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 void	GeoMeshView::setLeavesSubMesh(int submeshIndex)
 {
@@ -212,7 +215,7 @@
 }
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Gets the leaves submesh index.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 int	GeoMeshView::getLeavesSubMesh()
 {
@@ -220,7 +223,7 @@
 }
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Set the list of strip colors.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 void	GeoMeshView::setStripColors()
 {
@@ -253,9 +256,8 @@
 		}
 	}
-
 	
 	//	Sets random colors to each strip.
 	for (int submesh	= 0; submesh < geoMesh->mSubMeshCount; submesh++)
-	{
+	{	
 		//	Gets the actual submesh.
 		geosubmesh	=	&geoMesh->mSubMesh[submesh];
@@ -265,7 +267,7 @@
 			for	(int strip = 0; strip	<	geosubmesh->mStripCount; strip++)
 			{
-				mStripColors[submesh][strip].r	=	rand()/((float)RAND_MAX);
-				mStripColors[submesh][strip].g	=	rand()/((float)RAND_MAX);
-				mStripColors[submesh][strip].b	=	rand()/((float)RAND_MAX);
+				mStripColors[submesh][strip].r	=	(0.6 * rand() + 0.4 * (float)RAND_MAX)/((float)RAND_MAX);
+				mStripColors[submesh][strip].g	=	(0.6 * rand() + 0.4 * (float)RAND_MAX)/((float)RAND_MAX);
+				mStripColors[submesh][strip].b	=	(0.6 * rand() + 0.4 * (float)RAND_MAX)/((float)RAND_MAX);
 			}
 		}
@@ -276,119 +278,45 @@
 }
 
-/*
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Get the bounding box of the object.
-//---------------------------------------------------------------------------
-GeometryBounds	GeoMeshView::getBoundingBox()
-{
-	SubMesh					*geosubmesh;
-	Index						position;
-	Vector3					vector3;
-	GeometryBounds	bounds;
-	float						x,y,z;
-	float						xMin,yMin,zMin;
-	float						xMax,yMax,zMax;
-		
-	//	For each submesh.
-	for (int submesh = 0; submesh < geoMesh->mSubMeshCount; submesh++)
-	{
-		//	Gets the actual submesh.
-		geosubmesh	=	&geoMesh->mSubMesh[submesh];
-
-		//	For each index of the strip.
-		for (int index = 0; index < geosubmesh->mIndexCount; index++)
-		{
-			position	=	geosubmesh->mIndex[index];
-
-			//	Gets the vertex coordinates.
-			vector3	=	geosubmesh->mVertexBuffer->mPosition[position];
-				
-			x					=	vector3[0];
-			y					=	vector3[1];
-			z					=	vector3[2];
-				
-			//	If is the first iteation.
-			if ((submesh	== 0)	&&	(index	==	0))
-			{
-				xMin	=	xMax	=	x;
-				yMin	=	yMax	=	y;
-				zMin	=	zMax	=	z;
-			}
-			else
-			{
-				if (x < xMin)
-				{
-					xMin	=	x;
-				}
-				else if (x > xMax)
-				{
-					xMax	=	x;
-				}
-
-				if (y < yMin)
-				{
-					yMin	=	y;
-				}
-				else if (y > yMax)
-				{
-					yMax	=	y;
-				}
-
-				if (z < zMin)
-				{
-					zMin	=	z;
-				}
-				else if (z > zMax)
-				{
-					zMax	=	z;
-				}
-			}
-		}
-	}
-
-	xMed	=	(xMax + xMin)	/	2;
-	yMed	=	(yMax + yMin)	/	2;
-	zMed	=	(zMax + zMin)	/	2;
-
-
-	if ((xMax - xMin) > (yMax - yMin))
-	{
-		if ((xMax - xMin) > (zMax - zMin))
-		{
-			mScaleFactor	=	xMax - xMin;
-		}
-		else
-		{
-			mScaleFactor	=	zMax - zMin;
-		}
-	}
-	else
-	{
-		if ((yMax - yMin) > (zMax - zMin))
-		{
-			mScaleFactor	=	yMax - yMin;
-		}
-		else
-		{
-			mScaleFactor	=	zMax - zMin;
-		}
-	}
-
-	//	Set the bounds.
-	bounds.minx		=	xMin;
-	bounds.miny		=	yMin;
-	bounds.minz		=	zMin;
-	bounds.maxx		=	xMax;
-	bounds.maxy		=	yMax;
-	bounds.maxz		=	zMax;
-	bounds.radius	=	mScaleFactor;
-
-	return	bounds;
-}
-*/
-
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
+void	GeoMeshView::getBoundingBox()
+{
+	float	cx;
+	float	cy;
+	float	cz;
+	float	scale;
+
+	xMax	=	geoMesh->mMeshBounds.maxX;
+	yMax	=	geoMesh->mMeshBounds.maxY;
+	zMax	=	geoMesh->mMeshBounds.maxZ;
+	xMin	=	geoMesh->mMeshBounds.minX;
+	yMin	=	geoMesh->mMeshBounds.minY;
+	zMin	=	geoMesh->mMeshBounds.minZ;
+	scale	=	geoMesh->mMeshBounds.scaleFactor;
+	
+	//	Calculate center of the model.
+	cx = (xMax + xMin) / 2.0f;
+	cy = (yMax + yMin) / 2.0f;
+	cz = (zMax + zMin) / 2.0f;
+
+	xMax	-=	cx;
+	yMax	-=	cy;
+	zMax	-=	cz;
+	xMin	-=	cx;
+	yMin	-=	cy;
+	zMin	-=	cz;
+
+	xMax	*=	scale;
+	yMax	*=	scale;
+	zMax	*=	scale;
+	xMin	*=	scale;
+	yMin	*=	scale;
+	zMin	*=	scale;
+}
+
+//-------------------------------------------------------------------------
 //	Constructor.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 GeoMeshView::GeoMeshView(	int						x,
 													int						y,
@@ -446,7 +374,7 @@
 #define ALPHA 0.5
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Sets the Mesh to display.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 void GeoMeshView::setMesh(Mesh	*geomesh)
 {
@@ -458,4 +386,7 @@
 	mScaleFactor			=	geomesh->mMeshBounds.scaleFactor;
 	
+	//	Gets boundings of mesh.
+	getBoundingBox();
+
 	//	Refresh vertices to the vertex array.
 	refreshVertices(geomesh);
@@ -478,7 +409,7 @@
 }
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	 Refresh vertices to the vertex array.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 void	GeoMeshView::refreshVertices(Mesh	*geomesh)
 {
@@ -603,7 +534,7 @@
 }
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Gets the triangle count of the current lod.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 size_t	GeoMeshView::getLodStripsTriangleCount()
 {
@@ -618,7 +549,7 @@
 }
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Repaint the Mesh.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 void GeoMeshView::drawGeoMesh(bool	paintWire)
 {
@@ -667,7 +598,7 @@
 }//	End drawGeoMesh.
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Paint eah strip separately.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 void GeoMeshView::drawTriangleStrip(int submesh)
 {
@@ -745,5 +676,4 @@
 		}
 
-
 		//VERTEX ARRAYS
 		glEnableClientState(GL_VERTEX_ARRAY);
@@ -780,7 +710,7 @@
 }//End drawTriangleStrip.
 
-//---------------------------------------------------------------------------
-//	Paint the array of idices.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
+//	Paint the array of indices.
+//-------------------------------------------------------------------------
 void GeoMeshView::drawTriangleList(	int			submesh,
 																		bool 		selectedSubMesh,
@@ -895,7 +825,7 @@
 }//End drawTriangleList
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Paint lodstrip object.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 void GeoMeshView::drawLodStrip()
 {
@@ -970,7 +900,7 @@
 }//End drawTriangleStrip.
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Paint lodtree object.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 void GeoMeshView::drawLodTree()
 {
@@ -1090,7 +1020,7 @@
 }
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Sets the lodstripslibrary object.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 void	GeoMeshView::setLodStripsLibrary(LodStripsLibrary *lodstrips)
 {
@@ -1099,7 +1029,7 @@
 }
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Sets the lodtreeslibrary object.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 void	GeoMeshView::setLodTreesLibrary(LodTreeLibrary *lodtrees)
 {
@@ -1108,7 +1038,7 @@
 }
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Change de Level of detail of the object.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 void	GeoMeshView::GoToLod_LodStrip(float	lod)
 {
@@ -1126,7 +1056,7 @@
 }
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 //	Change de Level of detail of the object.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 void	GeoMeshView::GoToLod_LodTree(float	lod)
 {
@@ -1139,7 +1069,104 @@
 }
 
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
+//	Draw axes.
+//-------------------------------------------------------------------------
+void	GeoMeshView::drawAxes()
+{
+	float	max;
+
+	max	=	xMax;
+
+	if (yMax > max)
+	{
+		max = yMax;
+	}
+
+	if (zMax > max)
+	{
+		max = zMax;
+	}
+
+	glDisable(GL_LIGHTING);
+	glPolygonMode (GL_FRONT_AND_BACK, GL_LINE);
+	glDisable(GL_CULL_FACE);
+
+	//	Set white color to the object.
+	glColor3d(1.0, 0.0, 0.0);
+
+	//	X axis.
+	glBegin(GL_LINES);
+	glVertex3f(0.0f,0.0f,0.0f);
+	glVertex3f(max,0.0f,0.0f);
+	glEnd();
+
+	//	Set white color to the object.
+	glColor3d(0.0, 1.0, 0.0);
+
+	//	Y axis.
+	glBegin(GL_LINES);
+	glVertex3f(0.0f,0.0f,0.0f);
+	glVertex3f(0.0f,max,0.0f);
+	glEnd();
+
+	//	Set white color to the object.
+	glColor3d(0.0, 0.0, 1.0);
+
+	//	Z axis.
+	glBegin(GL_LINES);
+	glVertex3f(0.0f,0.0f,0.0f);
+	glVertex3f(0.0f,0.0f,max);
+	glEnd();
+}
+
+//-------------------------------------------------------------------------
+//	Draw bounding box.
+//-------------------------------------------------------------------------
+void	GeoMeshView::drawBoundingBox()
+{
+	glDisable(GL_LIGHTING);
+	glPolygonMode (GL_FRONT_AND_BACK, GL_LINE);
+	glDisable(GL_CULL_FACE);
+
+	//	Set white color to the object.
+	glColor3d(0.0, 0.0, 0.0);
+
+	glBegin(GL_QUADS);
+	glVertex3f(xMin,yMin,zMin);
+	glVertex3f(xMin,yMax,zMin);
+	glVertex3f(xMax,yMax,zMin);
+	glVertex3f(xMax,yMin,zMin);
+
+	glVertex3f(xMin,yMin,zMin);
+	glVertex3f(xMin,yMax,zMin);
+	glVertex3f(xMin,yMax,zMax);
+	glVertex3f(xMin,yMin,zMax);
+
+	glVertex3f(xMax,yMin,zMin);
+	glVertex3f(xMax,yMax,zMin);
+	glVertex3f(xMax,yMax,zMax);
+	glVertex3f(xMax,yMin,zMax);
+
+	glVertex3f(xMax,yMin,zMax);
+	glVertex3f(xMax,yMax,zMax);
+	glVertex3f(xMin,yMax,zMax);
+	glVertex3f(xMin,yMin,zMax);
+
+	glVertex3f(xMin,yMin,zMax);
+	glVertex3f(xMax,yMin,zMax);
+	glVertex3f(xMax,yMin,zMin);
+	glVertex3f(xMin,yMin,zMin);
+
+	glVertex3f(xMin,yMax,zMax);
+	glVertex3f(xMax,yMax,zMax);
+	glVertex3f(xMax,yMax,zMin);
+	glVertex3f(xMin,yMax,zMin);
+
+	glEnd();
+}
+
+//-------------------------------------------------------------------------
 //	Draw the object in the window.
-//---------------------------------------------------------------------------
+//-------------------------------------------------------------------------
 void GeoMeshView::draw()
 {
@@ -1182,13 +1209,34 @@
 	//glTranslatef(-xMed,-yMed,-zMed);
 
+	GLfloat color_blanco[]	=	{1.0f,1.0f,1.0f,1.0f};
+
+	glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,color_blanco);
+
+	glClearColor(0.3,0.3,0.3,0);
+	
+	if ((geoMesh != NULL) && mAxes)
+	{
+		//	Draw coordinates axes.
+		drawAxes();
+	}
+
+	if ((geoMesh != NULL) && mBBox)
+	{
+		//	Draw bounding box.
+		drawBoundingBox();
+	}
+
 	//	Set white color to the object.
 	glColor3d(1.0, 1.0, 1.0);
 
-	GLfloat color_blanco[]	=	{1.0f,1.0f,1.0f,1.0f};
-
-	glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,color_blanco);
-
-	glClearColor(0.3,0.3,0.3,0);
-	
+	if (mLighting)
+	{
+		glEnable(GL_LIGHTING);
+	}
+	else
+	{
+		glDisable(GL_LIGHTING);
+	}
+
 	if (mCW)
 	{
@@ -1214,13 +1262,4 @@
 		glPolygonMode (GL_FRONT_AND_BACK, GL_FILL);
 		drawGeoMesh(false);
-	}
-
-	if (mLighting)
-	{
-		glEnable(GL_LIGHTING);
-	}
-	else
-	{
-		glDisable(GL_LIGHTING);
 	}
 
@@ -1264,7 +1303,4 @@
 
 	swap_buffers();
-
-	//	Calculate the FPS.
-	//calcFPS();
 }
 
